/****************************************Copyright (c)*************************
**                               Ȩ (C), 2015-2020, ͿѻƼ
**
**                                 http://www.tuya.com
**
**--------------ļϢ-------------------------------------------------------
**      : User_Flash.c
**        : Timerû
**ʹ  ˵  : 
**
**
**--------------ǰ汾޶---------------------------------------------------

**   : v2.0
** ա: 2016329
** 衡: 1:Żṹ
**
**-----------------------------------------------------------------------------
******************************************************************************/
#define USER_FLASH_GLOBAL
#include "include.h"



/*****************************************************************************
 : IapIdle
 : رIAP
 : 
ز : 
*****************************************************************************/
static void IapIdle(void)
{
	IAP_CONTR = 0;                  //رIAP
	IAP_CMD = 0;                    //Ĵ
	IAP_TRIG = 0;                   //Ĵ
	IAP_ADDRH = 0x80;               //ַõIAP
	IAP_ADDRL = 0;
}
/*****************************************************************************
 : IapReadByte
 : ISP/IAP/EEPROMȡһֽ
 : addr:ʼַ
ز : 
*****************************************************************************/
static unsigned char IapReadByte(unsigned long addr)
{
	unsigned char dat;                       //ݻ

	IAP_CONTR = ENABLE_IAP;         //ʹIAP
	IAP_CMD = CMD_READ;             //IAP
	IAP_ADDRL = addr;               //IAP͵ַ
	IAP_ADDRH = addr >> 8;          //IAPߵַ
	IAP_TRIG = 0x5a;                //д(0x5a)
	IAP_TRIG = 0xa5;                //д(0xa5)
	_nop_();                        //ȴISP/IAP/EEPROM
	dat = IAP_DATA;                 //ISP/IAP/EEPROM
	IapIdle();                      //رIAP

	return dat;                     //
}
/*****************************************************************************
 : IapProgramByte
 : дһֽݵISP/IAP/EEPROM
 : addr:ʼַ/dat:д
ز : 
*****************************************************************************/
static void IapProgramByte(unsigned long addr, unsigned char dat)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_PROGRAM;          //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_DATA = dat;                 //дISP/IAP/EEPROM
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    IapIdle();
}
/*****************************************************************************
 : IapEraseSector
 : 
 : addr:ʼַ
ز : 
*****************************************************************************/
static void IapEraseSector(unsigned long addr)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_ERASE;            //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    IapIdle();
}
/*****************************************************************************
 : Write_Flash
 : Flashֽڱ
 : Addr_Sour:дԴ
           Addr_Obj:FLASHĿʼַ
           Length:дֽ
ز : SUCCESS:дɹ
            ERROR:дʧ
ʹ˵ : 
*****************************************************************************/
uint8_t Write_Flash(uint32_t Addr_Obj,uint8_t *Addr_Sour,uint16_t Length)
{
	uint16_t i;
	for(i = 0; i < Length; i ++)
	{
		IapProgramByte(Addr_Obj,*Addr_Sour);
		Addr_Obj ++;
		Addr_Sour ++;
	}
	return SUCCESS;
}
/*****************************************************************************
 : Earse_Flash
 : Flash
 : Addr_Obj:FLASHĿʼַ
ز : SUCCESS:ɹ
            ERROR:ʧ
ʹ˵ : 
*****************************************************************************/
uint8_t Earse_Flash(uint32_t Addr_Obj)
{
	IapEraseSector(Addr_Obj);
	
	return SUCCESS;
}
/*****************************************************************************
 : Read_Flash
 : ȡFLASH
 : pulData:Դ
           ulAddress:FLASHʼַ
           Length:ȡֽ
ز : true:ȡɹ
           false:ȡʧ
*****************************************************************************/
uint8_t Read_Flash(uint8_t *pulData,uint32_t ulAddress,uint32_t Length)
{
	uint16_t i;
	for(i = 0; i < Length; i ++)
	{
		*pulData = IapReadByte(ulAddress);
		ulAddress ++;
		pulData ++;
	}
		
	return SUCCESS;
}