/******************************************************************************
ļ: Uart.c
ļʶ: STC12SSA60S2
ժ    Ҫ: UartӲ
ǰ汾: V1.0	
: 2013.11.18
*******************************************************************************/
#define	USER_UART_GLOBALS
#include "include.h"
#include "wifi.h"



#define MAIN_Fosc		11059200L	//ʱ
#define	BaudRate		9600UL	//ѡ
#define	Timer1_Reload	(65536UL -(MAIN_Fosc / 4 / BaudRate))		//Timer 1 װֵ Ӧ300KHZ
#define	Timer2_Reload	(65536UL -(MAIN_Fosc / 4 / BaudRate))		//Timer 2 װֵ Ӧ300KHZ


/*****************************************************************************
 : uart1_init
 : uart1ʼ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
void uart1_init(void)
{
	S1_8bit();																																	//8λ
	S1_USE_P30P31();																														//UART1 ʹP30 P31	Ĭ
	AUXR &= ~(1<<4);																														//Timer stop		ʹTimer2
	AUXR |= 0x01;																																//S1 BRT Use Timer2;
	AUXR |=  (1<<2);																														//Timer2 set as 1T mode
	TH2 = (unsigned char)(Timer2_Reload >> 8);
	TL2 = (unsigned char)Timer2_Reload;
	AUXR |=  (1<<4);	//Timer run enable
	REN = 1;	//
	ES  = 1;	//ж
	EA = 1;		//ȫж
	PS=1;
	P3M1&=0XE7;
	P3M0|=0X18;
}
/*****************************************************************************
 : Uart_PutChar
 : ڷ
 : dat:
ز : 
ʹ˵ : 
*****************************************************************************/
void Uart_PutChar(unsigned char dat)
{
	SBUF = dat;
	while(!TI);
	TI = 0;
}
/*****************************************************************************
 : Uart1_ISR_Handle
 : Uart1жϴ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
void Uart1_ISR_Handle (void) interrupt UART1_VECTOR
{
	if(RI)
	{
		RI = 0;

		uart_receive_input(SBUF);		
	}
}
